import processing.core.*; 
import processing.data.*; 
import processing.opengl.*; 

import de.bezier.data.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class sunUpSunDown5 extends PApplet {

/*
If you use the UP/DOWN keys, you can shift the timezone of SF, 
so that you can improve light/dark
*/


// import library


// declare variables
XlsReader reader;

String title, title1;
int cols=8;
int SFextra=0;
int rows=365;
int[][] sunAmsterdam = new int[cols][rows];
int[][] sunNewYork = new int[cols][rows];
int[][] sunAuckland = new int[cols][rows];
int[][] sunSanFrancisco = new int[cols][rows];
int[][] sunJakarta = new int[cols][rows];
int[][] sunMilan = new int[cols][rows];

//int[] sun = new int[8];
int x; int y;
int earliest = 500;
int latest = 500; 
int lastMonth = 0;
int barColor = 250;
int offset = 10; // this is the margin to the left

// setup, all the work is done here

public void setup ()
{
  size(365*3+offset, 700);
  // size(100,100);
  stroke(2);
  fill( 0 );
  background( 255 );
  smooth();
  loadAmsterdam();
  loadSanFrancisco();

}

public void draw() {
  background(255);
  monthBars();
  hourLines();
  printAmsterdam();
  printSanFrancisco();

 /* if ((mouseX-offset)/3 > 0) {
    int xLocation = (mouseX-offset)/3;
    int tempTextMonth = sunAmsterdam[0][xLocation];
    int tempTextDay = sunAmsterdam[1][xLocation];
    int tempTextSunUpHour = sunAmsterdam[2][xLocation];
    int tempTextSunUpMin = sunAmsterdam[3][xLocation];
    int tempTextSunDownHour = sunAmsterdam[4][xLocation];
    int tempTextSunDownMin = sunAmsterdam[5][xLocation];
    int tempSunUpTimeY = sunAmsterdam[6][xLocation]/2;
    int tempSunDownTimeY = sunAmsterdam[7][xLocation]/2;
    int barLength = tempSunDownTimeY-tempSunUpTimeY;
    fill(255);
    noStroke();
    rect(0, 0, 500, 20);
    fill(200,0,0);
    text(tempTextDay + "/" + tempTextMonth  +" The Sun Rises at " + tempTextSunUpHour + ":" + tempTextSunUpMin + " The Sun Sets At " + tempTextSunDownHour + ":" + tempTextSunDownMin, 20, 20);
    rect(mouseX, tempSunUpTimeY, 3, barLength);
    fill(0);
  }*/
  
  

}
public void keyPressed() {
  if (key == CODED) {
    if (keyCode == UP) {
      SFextra++;
    } else if (keyCode == DOWN) {
      SFextra--;
    } 
  } else {
  }
}
public void loadSanFrancisco() {
  reader = new XlsReader( this, "sunriseSunsets.xls" );
  reader.openSheet(0);
  reader.firstRow();
  title1 = reader.getString();    // the title of the original dataset is in the first row, first cell
  reader.nextRow(); // legend
  while ( reader.hasMoreRows () )    // loop thru rows
  {
    // jump to first data row and its first cell
    // don't forget this or you'll be stuck in an endless loop
    reader.nextRow();    
    y = y+1;
    int month = reader.getInt();    // month
    sunSanFrancisco[0][y-1] = month;

    if ( month < 1 ) break;    // eyit loop once we reach the end of the values, and they become smaller than 1 basically

    reader.nextCell();    // day
    sunSanFrancisco[1][y-1] = reader.getInt(); 

    reader.nextCell();    // upHour
    sunSanFrancisco[2][y-1] = reader.getInt();

    reader.nextCell();    // upMin
    sunSanFrancisco[3][y-1] = reader.getInt(); 

    reader.nextCell();    // downHour
    sunSanFrancisco[4][y-1] = reader.getInt();

    reader.nextCell();    // downMin
    sunSanFrancisco[5][y-1] = reader.getInt();

    int upTime = (sunSanFrancisco[2][y-1]*60)+sunSanFrancisco[3][y-1];
    int downTime = (sunSanFrancisco[4][y-1]*60)+sunSanFrancisco[5][y-1];
    sunSanFrancisco[6][y-1] = upTime;
    sunSanFrancisco[7][y-1] = downTime;


    // determining the earliest and latest day, do this in a loop
    if (upTime < earliest) {
      earliest = upTime;
    }
    if (downTime > latest) {
      latest = downTime;
    }
  }
}
public void printSanFrancisco() {
  for (int y = 0; y<rows-1; y++) {
    int sunUpToday = (sunSanFrancisco[6][y])/2;
    int sunDownToday = (sunSanFrancisco[7][y])/2;
fill(200,0,0);
stroke(200,0,0);
    ellipse (offset+y*3, sunUpToday, 1, 1);
    ellipse (offset+y*3, sunDownToday, 1, 1);

 text(title1, offset+300, 10);
    fill(0,0,200);
stroke(0,0,200);
    ellipse (offset+y*3, sunUpToday+SFextra/2, 1, 1);
    ellipse (offset+y*3, sunDownToday+SFextra/2, 1, 1);
 noStroke();
 text("ideal " + title1, offset+600, 10);
 //println(SFextra);
  }
}

public void hourLines() {
  for (int hour = 1; hour<24; hour++) {
    stroke(255);
    line(offset, hour*60/2, width, hour*60/2);
    noStroke();
    fill(0, 100, 100);
    text(hour, 5, hour*60/2+2);
    stroke(0);
    fill(0);
  }
}

// determining the last month
public void monthBars() {
  for (int x = 0; x<rows-1; x++) {
    int thisMonth = (sunAmsterdam[0][x]);
    barColor = 128+(128/12*thisMonth);
    fill(barColor);
    noStroke();
    rect(offset+x*3, 30, 4, height);
    fill(0);
    stroke(2);
  }
  // en nu nog ergens weer de maanden boven zetten
  
}


public void loadAmsterdam() {
  reader = new XlsReader( this, "sunriseSunsets.xls" );
  reader.openSheet(1);
  reader.firstRow();
  title = reader.getString();    // the title of the original dataset is in the first row, first cell
  reader.nextRow(); // legend
  while ( reader.hasMoreRows () )    // loop thru rows
  {
    // jump to first data row and its first cell
    // don't forget this or you'll be stuck in an endless loop
    reader.nextRow();    
    x = x+1;
    int month = reader.getInt();    // month
    sunAmsterdam[0][x-1] = month;

    if ( month < 1 ) break;    // exit loop once we reach the end of the values, and they become smaller than 1 basically

    reader.nextCell();    // day
    sunAmsterdam[1][x-1] = reader.getInt(); 

    reader.nextCell();    // upHour
    sunAmsterdam[2][x-1] = reader.getInt();

    reader.nextCell();    // upMin
    sunAmsterdam[3][x-1] = reader.getInt(); 

    reader.nextCell();    // downHour
    sunAmsterdam[4][x-1] = reader.getInt();

    reader.nextCell();    // downMin
    sunAmsterdam[5][x-1] = reader.getInt();

    int upTime = (sunAmsterdam[2][x-1]*60)+sunAmsterdam[3][x-1];
    int downTime = (sunAmsterdam[4][x-1]*60)+sunAmsterdam[5][x-1];
    sunAmsterdam[6][x-1] = upTime;
    sunAmsterdam[7][x-1] = downTime;


    // determining the earliest and latest day, do this in a loop
    if (upTime < earliest) {
      earliest = upTime;
    }
    if (downTime > latest) {
      latest = downTime;
    }
  }
}
public void printAmsterdam() {
  for (int x = 0; x<rows-1; x++) {
    int sunUpToday = (sunAmsterdam[6][x])/2;
    int sunDownToday = (sunAmsterdam[7][x])/2;

fill(0,100,0);
stroke(0,100,0);
    ellipse (offset+x*3, sunUpToday, 1, 1);
    ellipse (offset+x*3, sunDownToday, 1, 1);
    text(title, offset, 10);
  }
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "sunUpSunDown5" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
