void loadAmsterdam() {
  reader = new XlsReader( this, "sunriseSunsets.xls" );
  reader.openSheet(1);
  reader.firstRow();
  title = reader.getString();    // the title of the original dataset is in the first row, first cell
  reader.nextRow(); // legend
  while ( reader.hasMoreRows () )    // loop thru rows
  {
    // jump to first data row and its first cell
    // don't forget this or you'll be stuck in an endless loop
    reader.nextRow();    
    x = x+1;
    int month = reader.getInt();    // month
    sunAmsterdam[0][x-1] = month;

    if ( month < 1 ) break;    // exit loop once we reach the end of the values, and they become smaller than 1 basically

    reader.nextCell();    // day
    sunAmsterdam[1][x-1] = reader.getInt(); 

    reader.nextCell();    // upHour
    sunAmsterdam[2][x-1] = reader.getInt();

    reader.nextCell();    // upMin
    sunAmsterdam[3][x-1] = reader.getInt(); 

    reader.nextCell();    // downHour
    sunAmsterdam[4][x-1] = reader.getInt();

    reader.nextCell();    // downMin
    sunAmsterdam[5][x-1] = reader.getInt();

    int upTime = (sunAmsterdam[2][x-1]*60)+sunAmsterdam[3][x-1];
    int downTime = (sunAmsterdam[4][x-1]*60)+sunAmsterdam[5][x-1];
    sunAmsterdam[6][x-1] = upTime;
    sunAmsterdam[7][x-1] = downTime;


    // determining the earliest and latest day, do this in a loop
    if (upTime < earliest) {
      earliest = upTime;
    }
    if (downTime > latest) {
      latest = downTime;
    }
  }
}
void printAmsterdam() {
  for (int x = 0; x<rows-1; x++) {
    int sunUpToday = (sunAmsterdam[6][x])/2;
    int sunDownToday = (sunAmsterdam[7][x])/2;

fill(0,100,0);
stroke(0,100,0);
    ellipse (offset+x*3, sunUpToday, 1, 1);
    ellipse (offset+x*3, sunDownToday, 1, 1);
    text(title, offset, 10);
  }
}

